unit Custom;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls;

type
  TCustomDialog = class(TForm)
    Bevel1: TBevel;
    btBefore: TButton;
    btNext: TButton;
    btCancel: TButton;
    Label1: TLabel;
    InstallType: TRadioGroup;
    Label2: TLabel;
    procedure btBeforeClick(Sender: TObject);
    procedure btNextClick(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Initilisation(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CustomDialog: TCustomDialog;

implementation

uses Decla,Generale;

{$R *.DFM}

(* back button *)
procedure TCustomDialog.btBeforeClick(Sender: TObject);
begin
 if InstallType.ItemIndex = 0 then CustomizeFlg := False
                              else CustomizeFlg := True;
 CurrentWin := 1;
 Direction := 1;
 Close;
end;

(* Next Button *)
procedure TCustomDialog.btNextClick(Sender: TObject);
begin
 if InstallType.ItemIndex = 0 then CustomizeFlg := False
                              else CustomizeFlg := True;
 if CustomizeFlg = true then
  CurrentWin := 2
 else
 (* standard install *)
 begin
  UnInstallCop := true;
  UnInstallFil := true;
  CurrentWin := 5;
 end;
 Direction := 0;
 Close;
end;

(* cancel button *)
procedure TCustomDialog.btCancelClick(Sender: TObject);
begin
 MainBack.Close;
end;

(* closing procedure *)
procedure TCustomDialog.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 MainBack.Initialisation (Sender);
end;

(* init dialog *)
procedure TCustomDialog.Initilisation(Sender: TObject);
begin
 if CustomizeFlg = false then
  InstallType.ItemIndex := 0
 else
  InstallType.ItemIndex := 1;
end;

end.
